package ru.dbotthepony.mc.otm.capability.drive;

import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.common.util.INBTSerializable;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;
import java.util.UUID;
import java.util.function.Predicate;

public interface IMatteryDrive {
	List<StoredStack> getItems();

	boolean isDirty();
	void markDirty();
	void markClean();

	/**
	 * @param item
	 * @return all items belonging to passed class
	 */
	@Nonnull
	List<StoredStack> findItems(@Nonnull Item item);

	/**
	 * @param stack
	 * @return all items that match this itemstack
	 */
	@Nonnull
	List<StoredStack> findItems(@Nonnull ItemStack stack);

	@Nullable
	StoredStack getItem(@Nonnull UUID id);

	int getStoredCount();
	int getCapacity();

	@Nonnull
	ItemStack insertItem(@Nonnull ItemStack item, boolean simulate);

	@Nonnull
	default ItemStack extractItem(@Nonnull UUID id, int amount, boolean simulate) {
		return extractItem(id, amount, true, simulate);
	}

	@Nonnull
	ItemStack extractItem(@Nonnull UUID id, int amount, boolean obey_stack_size, boolean simulate);

	// not extending INBTSerializable to avoid serializing it as forgecaps
	CompoundTag serializeNBT();
	void deserializeNBT(CompoundTag nbt);
}
